<template>
<div class="mt-4">
    <h3>{{ title }}</h3>
    
    <div v-if="errors.length > 0" class="alert alert-danger">
      <ul>
        <li v-for="(error, index) in errors" :key="index">{{ error }}</li>
      </ul>
    </div>

    <form>
      <div class="mb-3">
        <label for="company_name" class="form-label">Company Name</label>
        <input
          class="border-2 rounded p-3 form-control"
          name="company_name"
          v-model="formFields.company_name"
          required
          />
      </div>
      <div class="mb-3">
        <label for="address" class="form-label">Address</label>
        <input
            class="border-2 rounded p-3 form-control"
            name="address"
            v-model="formFields.address"
        />
      </div>
      <div class="mb-3">
        <label for="phone" class="form-label">Phone</label>
        <input
            class="border-2 rounded p-3 form-control"
            name="phone"
            v-model="formFields.phone"
        />
      </div>
    </form>

    <div>
      <button @click="saveClient" type="submit" class="py-3 px-5 rounded bg-green-500 text-lg right">Submit</button>
      <button @click="cancelEdit" class="py-3 px-5 ml-3 rounded bg-gray-200 text-lg right">Cancel</button>
    </div>
  </div>
</template>

<script>
  export default {
    name: 'EditClient',
    data: function() {
      return {
        formFields: {
          company_name: '',
          address: '',
          phone: ''
        },
        title: 'Add New Client',
        errors: []
      }
    },
    mounted() {
      if (this.$route.params.id) {
        this.$store.dispatch('clients/getClient', this.$route.params.id)
          .then((res) => {
              this.formFields = { ...res.data }
              this.title = 'Edit ' + res.data.company_name;
          })
      }
    },
    methods: {
      saveClient() {
        if (this.$route.params.id) {
          // use method spoofing for put request
          this.formFields._method = 'PUT'
        }
        this.$store.dispatch('clients/createOrUpdateClient', {
          clientId: this.$route.params.id?? '',
          data: this.formFields
        }).then((res) => {
          // clear form fields value after success
          this.formFields = {}
          this.$router.push('/clients')
        }).catch((error) => {
          if (error.response.status == 422) {
            let errorsObj = error.response.data.errors;
            
            // use reduce to combine object of errors array to a single array
            this.errors = Object.values(errorsObj)
                            .reduce((a, b) => a.concat(b), [])
          }
        })
      },
      cancelEdit() {
        this.$router.push('/clients')
      }
    }
  }
</script>
